/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-08 01:16
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 2e5 + 5;
const ll INF = 1LL << 60;

pair<cp, cp> _closest(cp Px[], cp Py[], int n) {
  cp a, b;
  if (n <= 3) {
    lf mn = INFINITY;
    for(int i = 0; i < n; i++)
      for (int j = i + 1; j < n; j++)
        if(abs(Px[i] - Px[j]) < mn){
            a = Px[i], b = Px[j];
            mn = abs(a - b);
        }
        /* mn = min(mn, abs(Px[i] - Px[j])); */
    return {a, b};
  }
  cp Pyl[n/2 + 1], Pyr[n - n/2];
  int li = 0, ri = 0;
  for (int i = 0; i < n; i++)
    if (real(Py[i]) <= real(Px[n/2])) Pyl[li++] = Py[i];
    else Pyr[ri++] = Py[i];
  /* lf d = min(_closest(Px, Pyl, n/2), _closest(Px + n/2, Pyr, n - n/2)); */
  auto [p, q] = _closest(Px, Pyl, n/2);
  auto [s, t] = _closest(Px + n/2, Pyr, n - n/2);
  if(abs(p - q) < abs(s - t))
      a = p, b = q;
  else
      a = s, b = t;
  lf d = abs(a - b);
  vector<cp> strip;
  auto pred = [&](cp a) { return abs(real(a) - real(Px[n/2])) < d; };
  copy_if(Py, Py + n, back_inserter(strip), pred);
  for (int i = 0; i < ssize(strip); i++)
    for (int j = i + 1; j < ssize(strip) && (imag(strip[j]) - imag(strip[i])) < d; j++)
      /* d = min(d, abs(strip[i] - strip[j])); */
        if(abs(strip[i] - strip[j]) < d){
            a = strip[i], b = strip[j];
            d = abs(a - b);
        }
  return {a, b};
}
pair<cp,cp> closest(vector<cp> P) {
  vector Py(P);
  R::sort(P, {}, [](cp a) { return real(a); });
  R::sort(Py, {}, [](cp a) { return imag(a); });
  return _closest(data(P), data(Py), ssize(P));
}


ifstream fin("input.txt");
ofstream fout("output.txt");


ll N;

void solve(){
    // Code goes here ...
    fin >> N;
    vector<int> xs(N), ys(N);
    R(i, N) fin >> xs[i] >> ys[i];  
    
    vector<cp> points(N);
    vector<int> ks(N);
    R(i, N){
        points[i] = {abs(xs[i]), abs(ys[i])};
        ks[i] = 1 + (xs[i] < 0 ? 1 : 0) + (ys[i] < 0 ? 2 : 0);
    }

    cp a, b;
    tie(a, b) = closest(points);

    int ia = -1, ka, ib = -1, kb;
    R(i, N){
        if(a == points[i]) ia = i;
        if(b == points[i]) ib = i;
    }

    /* assert(ia != -1 and ib != -1); */
    if(ia == -1 or ib == -1){
        cout << "NOOO" << endl;
        return;
    }
    ka = ks[ia];
    kb = 5 - ks[ib];

    /* cerr << "Closest points are: " << points[ia] << " and " << points[ib] << endl; */
    /* cerr << " with conversion numbers " << ka << " and " << 5 - kb << endl; */

    fout << ia + 1 << " " << ka << " " << ib + 1 << " " << kb << endl;
    /* fout << format("%d %d %d %d\n", ia + 1, ka, ib + 1, kb); */
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); fin.tie(0);
    cout << setprecision(12); // << fixed;

    /* int T = 1; */
    /* cin >> T; */
    /* while(T--) */
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
